from casioplot import *
from math import *


def pixel(x,y,color,size):
  for i in range(x,x + size):
    for j in range(y,y + size):
      set_pixel(i,j,color)

def liney(x1,y1,x2,y2,color):
  dx = x2-x1
  dy = y2-y1
  yi = 1
  if dy < 0:
    yi = -1
    dy = -dy
  d = (2*dy)-dx
  y = y1
  for x in range(x1,x2):
    set_pixel(x,y,color)
    if d > 0:
      y += yi
      d += 2*(dy-dx)
    else:
      d += 2*dy

def linex(x1,y1,x2,y2,color):
  dx = x2-x1
  dy = y2-y1
  xi = 1
  if dx < 0:
    xi = -1
    dx = -dx
  d = (2*dx)-dy
  x = x1
  for y in range(y1,y2):
    set_pixel(x,y,color)
    if d > 0:
      x += xi
      d += 2*(dx-dy)
    else:
      d += 2*dx

def line(x1,y1,x2,y2,color):
  if abs(y2-y1) < abs(x2-x1):
    if x1 > x2:
      liney(x2,y2,x1,y1,color)
    else:
      liney(x1,y1,x2,y2,color)
  else:
    if y1 > y2:
      linex(x2,y2,x1,y1,color)
    else:
      linex(x1,y1,x2,y2,color)

def rect(x1,y1,x2,y2,color):
  for i in range(x1,x2):
    for j in range(y1,y2):
      set_pixel(i,j,color)

def circle(x,y,r,color):
  xp = 0
  yp = r
  d = 3-2*r
  while yp >= xp:
    if d > 0:
      yp -= 1
      d = d+4*(xp-yp)+10
    else:
      d = d+4*xp+6
    set_pixel(x+xp,y+yp,color)
    set_pixel(x-xp,y+yp,color)
    set_pixel(x+xp,y-yp,color)
    set_pixel(x-xp,y-yp,color)
    set_pixel(x+yp,y+xp,color)
    set_pixel(x-yp,y+xp,color)
    set_pixel(x+yp,y-xp,color)
    set_pixel(x-yp,y-xp,color)
    xp += 1

def full_circle(x,y,r,color):
  for yi in range(-r,r):
    for xi in range(-r,r):
      if xi**2+yi**2 < r**2:
        set_pixel(x+xi,y+yi,color)

def ellipse(x,y,rx,ry,color):
  if rx == ry:
    circle(x,y,rx,color)
    return
  
  for a in range(0,2*314,1):
    xi = round(cos(a/100)*rx)
    yi = round(sin(a/100)*ry)
    set_pixel(x+xi,y+yi,color)

#clear_screen()
#set_pixel(383,191,[0,0,0])
#set_pixel(191,95,[0,0,0])
#ellipse(191,95,191,95,(0,0,0))
#show_screen()
